---
product: "AG Studio"
title: "Data Types"
description: "Studio supports a variety of data types. Instead of being defined directly on fields, data types are defined on . A Format controls formatting along with other behaviour."
framework: javascript
version: "3.0.0"
related:
    - title: "Formatting"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/formatting/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/expressions/"
    - title: "Calendars"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/calendars/"
    - title: "Editable Fields"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/creating-editing-fields/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Data Types

Studio supports a variety of data types. Instead of being defined directly on fields, data types are defined on [Formats](https://www.ag-grid.com/studio/archive/3.0.0/javascript/formatting/). A Format controls formatting along with other behaviour.

```
const fields = [
    {
        id: 'athlete',
        format: 'textFormat' // textFormat uses the `string` data type
    },
    // ... other fields
];
```

When using [Sync Data](https://www.ag-grid.com/studio/archive/3.0.0/javascript/loading-data/#sync-data) and not providing fields, the format is inferred from the data.

#### Data Types

```ts
import {
  AgFieldDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "1": {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "dataTypes.string" },
              { id: "dataTypes.integer" },
              { id: "dataTypes.decimal" },
              { id: "dataTypes.boolean" },
              { id: "dataTypes.date" },
              { id: "dataTypes.datetime" },
            ],
          },
        },
      },
      widgetLayout: {
        "1": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 25,
        },
      },
    },
  ],
  selectedPageId: "a",
  panels: {
    filters: {
      collapsed: true,
    },
    edit: {
      collapsed: true,
    },
  },
};

const fields: AgFieldDefinition[] = [
  {
    id: "string",
    format: "textFormat",
  },
  {
    id: "integer",
    format: "integerFormat",
  },
  {
    id: "decimal",
    format: "decimalFormat",
  },
  {
    id: "boolean",
    format: "booleanFormat",
  },
  {
    id: "date",
    format: "dateFormat",
  },
  {
    id: "datetime",
    format: "dateTimeFormat",
  },
];

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", {
      sources: [
        {
          id: "dataTypes",
          data: data.slice(0, 100).map((row: any) => {
            const datetime = new Date(row.date);
            datetime.setHours(Math.floor(window.agRandom() * 24));
            datetime.setMinutes(Math.floor(window.agRandom() * 60));
            datetime.setSeconds(Math.floor(window.agRandom() * 60));
            return {
              string: row.athlete,
              integer: row.total,
              decimal: row.total * window.agRandom(),
              boolean: !!row.gold,
              date: row.date,
              datetime,
            };
          }),
          fields,
        },
      ],
    }),
  );
```

[Live example: Data Types](https://www.ag-grid.com/studio/archive/3.0.0/examples/data-types/data-types/typescript/)

## Data Types

Each of the data types are described in the table below. The input type is the JavaScript type that is supported in the source data. The default Format is the Format that will be used when inferring fields.

| Data Type | Input Type | Default Format |
| --- | --- | --- |
| `string` | `string` | `textFormat` |
| `number` | `number` | `integerFormat` / `decimalFormat` |
| `boolean` | `boolean` | `booleanFormat` |
| `date` | `Date \| string \| number` | `dateFormat` |
| `datetime` | `Date \| string \| number` | `dateTimeFormat` |

For `date` and `datetime`, the `string` value is expected to be in ISO-8601 format, and the `number` value is Unix epoch.

See [Formatting](https://www.ag-grid.com/studio/archive/3.0.0/javascript/formatting/) for how each data type is displayed and how to customise the display format.

## Dictionary Columns

Some data stores a code rather than a label, such as an ISO country code instead of a country name. In Studio, the mapping from code to label is a separate table joined to the table holding the codes, and the user-facing column comes from that dictionary table.

This is not the same as formatting the code for display. Because the label is a real field, you can group, sort, filter and aggregate by it, put it on a chart axis, and use it in an expression. A value formatter only changes what is displayed, so the engine still groups, sorts and filters on the raw code. The mapping is also data, so you can update it without changing any code.

The example below joins a medals table to a countries dictionary. The medals table stores an ISO country code, and the grid shows the country name that the dictionary maps it to.

#### Dictionary Columns

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "1": {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "countries.countryName" },
              { id: "medals.sport" },
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
              { id: "medals.total", aggregation: "sum" },
            ],
          },
        },
      },
      widgetLayout: {
        "1": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 25,
        },
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    edit: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => studioApi!.setProperty("data", getData(data)));
```

[Live example: Dictionary Columns](https://www.ag-grid.com/studio/archive/3.0.0/examples/data-types/dictionary-columns/typescript/)

The medals table joins many-to-one to the countries table on the code. The code itself is hidden on both tables, so it does not appear in the field panel. A hidden field can still be used as a join key.

```js
const studioProperties = {
    sources: [{
        id: 'medals',
        data: [
            {
                sport: 'Swimming',
                countryCode: 'USA',
                // ... other fields
            },
            // ... other rows
        ],
        fields: [
            { id: 'countryCode', format: 'textFormat', hide: true },
            // ... other fields
        ],
    }, {
        id: 'countries',
        data: [
            { countryCode: 'USA', countryName: 'United States' },
            // ... one row per code
        ],
        fields: [
            { id: 'countryCode', format: 'textFormat', hide: true },
            { id: 'countryName', format: 'textFormat', name: 'Country' },
        ],
    }],
    relationships: [
        {
            id: 'medals-countries',
            source: {
                tableId: 'medals',
                fieldId: 'countryCode',
            },
            target: {
                tableId: 'countries',
                fieldId: 'countryCode',
            },
            type: 'many-to-one',
        },
    ],

    // other studio properties ...
}
```

Give the dictionary exactly one row per code. A duplicate code turns the join into a one-to-many, which inflates aggregated values. A code with no matching dictionary row leaves the label blank, as described in [Null and Undefined Values](https://www.ag-grid.com/studio/archive/3.0.0/javascript/data-types/#null-and-undefined-values).

See [Relationships](https://www.ag-grid.com/studio/archive/3.0.0/javascript/data-modelling/#relationships) for how relationships are defined, and [Star Schema](https://www.ag-grid.com/studio/archive/3.0.0/javascript/data-modelling/#star-schema) for modelling several dictionary tables around one table of facts.

## Null and Undefined Values

A field value can be missing - either `null` or `undefined`. AG Studio treats both the same way by default, across every data type.

### Display

A missing value is never passed to a Format's value formatter. Instead, the field shows that Format's `blankValue`:

| Data Type | Default Format | Blank display |
| --- | --- | --- |
| `string` | `textFormat` | `(Blanks)` |
| `number` | `integerFormat` / `decimalFormat` | `N/A` |
| `boolean` | `booleanFormat` | (empty) |
| `date` / `datetime` | `dateFormat` / `dateTimeFormat` | (empty) |

### Sorting

A missing value sorts as the smallest value by default, ahead of every other value in the field's data type, following the ascending-sort convention used by leading analytics and BI tools.

### Filtering

A missing value is excluded from filter results by default - for example, an `equals` or `between` condition never matches it.

### Aggregation

`sum`, `avg`, `min`, and `max` exclude missing values from the calculation. If every value in a group is missing, the result is `null` rather than `0` - this is standard practice across analytical engines, since a missing result and a true zero mean different things and collapsing them would hide information. `count` also excludes missing values.

`countd` (distinct count) counts a missing value as a distinct value by default, consistent with standard distinct-count semantics in analytical engines. `first` and `last` return the first or last non-missing value in sort order by default. Grouping treats a missing value as its own group rather than dropping those rows.


---
product: "AG Studio"
title: "Data Types"
description: "Studio supports a variety of data types. Instead of being defined directly on fields, data types are defined on . A Format controls formatting along with other behaviour."
framework: vue
version: "3.0.0"
related:
    - title: "Formatting"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/formatting/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/expressions/"
    - title: "Calendars"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/calendars/"
    - title: "Editable Fields"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/creating-editing-fields/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Data Types

Studio supports a variety of data types. Instead of being defined directly on fields, data types are defined on [Formats](https://www.ag-grid.com/studio/archive/3.0.0/vue/formatting/). A Format controls formatting along with other behaviour.

```
const fields = [
    {
        id: 'athlete',
        format: 'textFormat' // textFormat uses the `string` data type
    },
    // ... other fields
];
```

When using [Sync Data](https://www.ag-grid.com/studio/archive/3.0.0/vue/loading-data/#sync-data) and not providing fields, the format is inferred from the data.

#### Data Types

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgFieldDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const fields: AgFieldDefinition[] = [
  {
    id: "string",
    format: "textFormat",
  },
  {
    id: "integer",
    format: "integerFormat",
  },
  {
    id: "decimal",
    format: "decimalFormat",
  },
  {
    id: "boolean",
    format: "booleanFormat",
  },
  {
    id: "date",
    format: "dateFormat",
  },
  {
    id: "datetime",
    format: "dateTimeFormat",
  },
];

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "1": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "dataTypes.string" },
                  { id: "dataTypes.integer" },
                  { id: "dataTypes.decimal" },
                  { id: "dataTypes.boolean" },
                  { id: "dataTypes.date" },
                  { id: "dataTypes.datetime" },
                ],
              },
            },
          },
          widgetLayout: {
            "1": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 25,
            },
          },
        },
      ],
      selectedPageId: "a",
      panels: {
        filters: {
          collapsed: true,
        },
        edit: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({
        sources: [
          {
            id: "dataTypes",
            data: data.slice(0, 100).map((row: any) => {
              const datetime = new Date(row.date);
              datetime.setHours(Math.floor(window.agRandom() * 24));
              datetime.setMinutes(Math.floor(window.agRandom() * 60));
              datetime.setSeconds(Math.floor(window.agRandom() * 60));
              return {
                string: row.athlete,
                integer: row.total,
                decimal: row.total * window.agRandom(),
                boolean: !!row.gold,
                date: row.date,
                datetime,
              };
            }),
            fields,
          },
        ],
      });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Data Types](https://www.ag-grid.com/studio/archive/3.0.0/examples/data-types/data-types/vue3/)

## Data Types

Each of the data types are described in the table below. The input type is the JavaScript type that is supported in the source data. The default Format is the Format that will be used when inferring fields.

| Data Type | Input Type | Default Format |
| --- | --- | --- |
| `string` | `string` | `textFormat` |
| `number` | `number` | `integerFormat` / `decimalFormat` |
| `boolean` | `boolean` | `booleanFormat` |
| `date` | `Date \| string \| number` | `dateFormat` |
| `datetime` | `Date \| string \| number` | `dateTimeFormat` |

For `date` and `datetime`, the `string` value is expected to be in ISO-8601 format, and the `number` value is Unix epoch.

See [Formatting](https://www.ag-grid.com/studio/archive/3.0.0/vue/formatting/) for how each data type is displayed and how to customise the display format.

## Dictionary Columns

Some data stores a code rather than a label, such as an ISO country code instead of a country name. In Studio, the mapping from code to label is a separate table joined to the table holding the codes, and the user-facing column comes from that dictionary table.

This is not the same as formatting the code for display. Because the label is a real field, you can group, sort, filter and aggregate by it, put it on a chart axis, and use it in an expression. A value formatter only changes what is displayed, so the engine still groups, sorts and filters on the raw code. The mapping is also data, so you can update it without changing any code.

The example below joins a medals table to a countries dictionary. The medals table stores an ISO country code, and the grid shows the country name that the dictionary maps it to.

#### Dictionary Columns

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "1": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "countries.countryName" },
                  { id: "medals.sport" },
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                  { id: "medals.total", aggregation: "sum" },
                ],
              },
            },
          },
          widgetLayout: {
            "1": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 25,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        edit: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => getData(data);

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Dictionary Columns](https://www.ag-grid.com/studio/archive/3.0.0/examples/data-types/dictionary-columns/vue3/)

The medals table joins many-to-one to the countries table on the code. The code itself is hidden on both tables, so it does not appear in the field panel. A hidden field can still be used as a join key.

```ts
<ag-studio
    :sources="sources"
    :relationships="relationships"
    /* other studio properties ... */>
</ag-studio>

this.sources = [{
    id: 'medals',
    data: [
        {
            sport: 'Swimming',
            countryCode: 'USA',
            // ... other fields
        },
        // ... other rows
    ],
    fields: [
        { id: 'countryCode', format: 'textFormat', hide: true },
        // ... other fields
    ],
}, {
    id: 'countries',
    data: [
        { countryCode: 'USA', countryName: 'United States' },
        // ... one row per code
    ],
    fields: [
        { id: 'countryCode', format: 'textFormat', hide: true },
        { id: 'countryName', format: 'textFormat', name: 'Country' },
    ],
}];
this.relationships = [
    {
        id: 'medals-countries',
        source: {
            tableId: 'medals',
            fieldId: 'countryCode',
        },
        target: {
            tableId: 'countries',
            fieldId: 'countryCode',
        },
        type: 'many-to-one',
    },
];
```

Give the dictionary exactly one row per code. A duplicate code turns the join into a one-to-many, which inflates aggregated values. A code with no matching dictionary row leaves the label blank, as described in [Null and Undefined Values](https://www.ag-grid.com/studio/archive/3.0.0/vue/data-types/#null-and-undefined-values).

See [Relationships](https://www.ag-grid.com/studio/archive/3.0.0/vue/data-modelling/#relationships) for how relationships are defined, and [Star Schema](https://www.ag-grid.com/studio/archive/3.0.0/vue/data-modelling/#star-schema) for modelling several dictionary tables around one table of facts.

## Null and Undefined Values

A field value can be missing - either `null` or `undefined`. AG Studio treats both the same way by default, across every data type.

### Display

A missing value is never passed to a Format's value formatter. Instead, the field shows that Format's `blankValue`:

| Data Type | Default Format | Blank display |
| --- | --- | --- |
| `string` | `textFormat` | `(Blanks)` |
| `number` | `integerFormat` / `decimalFormat` | `N/A` |
| `boolean` | `booleanFormat` | (empty) |
| `date` / `datetime` | `dateFormat` / `dateTimeFormat` | (empty) |

### Sorting

A missing value sorts as the smallest value by default, ahead of every other value in the field's data type, following the ascending-sort convention used by leading analytics and BI tools.

### Filtering

A missing value is excluded from filter results by default - for example, an `equals` or `between` condition never matches it.

### Aggregation

`sum`, `avg`, `min`, and `max` exclude missing values from the calculation. If every value in a group is missing, the result is `null` rather than `0` - this is standard practice across analytical engines, since a missing result and a true zero mean different things and collapsing them would hide information. `count` also excludes missing values.

`countd` (distinct count) counts a missing value as a distinct value by default, consistent with standard distinct-count semantics in analytical engines. `first` and `last` return the first or last non-missing value in sort order by default. Grouping treats a missing value as its own group rather than dropping those rows.


---
product: "AG Studio"
title: "Data Types"
description: "Studio supports a variety of data types. Instead of being defined directly on fields, data types are defined on . A Format controls formatting along with other behaviour."
framework: react
version: "3.0.0"
related:
    - title: "Formatting"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/formatting/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/expressions/"
    - title: "Calendars"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/calendars/"
    - title: "Editable Fields"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/creating-editing-fields/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Data Types

Studio supports a variety of data types. Instead of being defined directly on fields, data types are defined on [Formats](https://www.ag-grid.com/studio/archive/3.0.0/react/formatting/). A Format controls formatting along with other behaviour.

```
const fields = [
    {
        id: 'athlete',
        format: 'textFormat' // textFormat uses the `string` data type
    },
    // ... other fields
];
```

When using [Sync Data](https://www.ag-grid.com/studio/archive/3.0.0/react/loading-data/#sync-data) and not providing fields, the format is inferred from the data.

#### Data Types

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgFieldDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const fields: AgFieldDefinition[] = [
  {
    id: "string",
    format: "textFormat",
  },
  {
    id: "integer",
    format: "integerFormat",
  },
  {
    id: "decimal",
    format: "decimalFormat",
  },
  {
    id: "boolean",
    format: "booleanFormat",
  },
  {
    id: "date",
    format: "dateFormat",
  },
  {
    id: "datetime",
    format: "dateTimeFormat",
  },
];

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "1": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "dataTypes.string" },
                  { id: "dataTypes.integer" },
                  { id: "dataTypes.decimal" },
                  { id: "dataTypes.boolean" },
                  { id: "dataTypes.date" },
                  { id: "dataTypes.datetime" },
                ],
              },
            },
          },
          widgetLayout: {
            "1": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 25,
            },
          },
        },
      ],
      selectedPageId: "a",
      panels: {
        filters: {
          collapsed: true,
        },
        edit: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) =>
        setData({
          sources: [
            {
              id: "dataTypes",
              data: data.slice(0, 100).map((row: any) => {
                const datetime = new Date(row.date);
                datetime.setHours(Math.floor(window.agRandom() * 24));
                datetime.setMinutes(Math.floor(window.agRandom() * 60));
                datetime.setSeconds(Math.floor(window.agRandom() * 60));
                return {
                  string: row.athlete,
                  integer: row.total,
                  decimal: row.total * window.agRandom(),
                  boolean: !!row.gold,
                  date: row.date,
                  datetime,
                };
              }),
              fields,
            },
          ],
        }),
      );
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Data Types](https://www.ag-grid.com/studio/archive/3.0.0/examples/data-types/data-types/reactFunctionalTs/)

## Data Types

Each of the data types are described in the table below. The input type is the JavaScript type that is supported in the source data. The default Format is the Format that will be used when inferring fields.

| Data Type | Input Type | Default Format |
| --- | --- | --- |
| `string` | `string` | `textFormat` |
| `number` | `number` | `integerFormat` / `decimalFormat` |
| `boolean` | `boolean` | `booleanFormat` |
| `date` | `Date \| string \| number` | `dateFormat` |
| `datetime` | `Date \| string \| number` | `dateTimeFormat` |

For `date` and `datetime`, the `string` value is expected to be in ISO-8601 format, and the `number` value is Unix epoch.

See [Formatting](https://www.ag-grid.com/studio/archive/3.0.0/react/formatting/) for how each data type is displayed and how to customise the display format.

## Dictionary Columns

Some data stores a code rather than a label, such as an ISO country code instead of a country name. In Studio, the mapping from code to label is a separate table joined to the table holding the codes, and the user-facing column comes from that dictionary table.

This is not the same as formatting the code for display. Because the label is a real field, you can group, sort, filter and aggregate by it, put it on a chart axis, and use it in an expression. A value formatter only changes what is displayed, so the engine still groups, sorts and filters on the raw code. The mapping is also data, so you can update it without changing any code.

The example below joins a medals table to a countries dictionary. The medals table stores an ISO country code, and the grid shows the country name that the dictionary maps it to.

#### Dictionary Columns

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "1": {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "countries.countryName" },
                  { id: "medals.sport" },
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                  { id: "medals.total", aggregation: "sum" },
                ],
              },
            },
          },
          widgetLayout: {
            "1": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 25,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        edit: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData(getData(data)));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Dictionary Columns](https://www.ag-grid.com/studio/archive/3.0.0/examples/data-types/dictionary-columns/reactFunctionalTs/)

The medals table joins many-to-one to the countries table on the code. The code itself is hidden on both tables, so it does not appear in the field panel. A hidden field can still be used as a join key.

```jsx
const sources = [{
    id: 'medals',
    data: [
        {
            sport: 'Swimming',
            countryCode: 'USA',
            // ... other fields
        },
        // ... other rows
    ],
    fields: [
        { id: 'countryCode', format: 'textFormat', hide: true },
        // ... other fields
    ],
}, {
    id: 'countries',
    data: [
        { countryCode: 'USA', countryName: 'United States' },
        // ... one row per code
    ],
    fields: [
        { id: 'countryCode', format: 'textFormat', hide: true },
        { id: 'countryName', format: 'textFormat', name: 'Country' },
    ],
}];
const relationships = [
    {
        id: 'medals-countries',
        source: {
            tableId: 'medals',
            fieldId: 'countryCode',
        },
        target: {
            tableId: 'countries',
            fieldId: 'countryCode',
        },
        type: 'many-to-one',
    },
];

<AgStudio
    sources={sources}
    relationships={relationships}
/>
```

Give the dictionary exactly one row per code. A duplicate code turns the join into a one-to-many, which inflates aggregated values. A code with no matching dictionary row leaves the label blank, as described in [Null and Undefined Values](https://www.ag-grid.com/studio/archive/3.0.0/react/data-types/#null-and-undefined-values).

See [Relationships](https://www.ag-grid.com/studio/archive/3.0.0/react/data-modelling/#relationships) for how relationships are defined, and [Star Schema](https://www.ag-grid.com/studio/archive/3.0.0/react/data-modelling/#star-schema) for modelling several dictionary tables around one table of facts.

## Null and Undefined Values

A field value can be missing - either `null` or `undefined`. AG Studio treats both the same way by default, across every data type.

### Display

A missing value is never passed to a Format's value formatter. Instead, the field shows that Format's `blankValue`:

| Data Type | Default Format | Blank display |
| --- | --- | --- |
| `string` | `textFormat` | `(Blanks)` |
| `number` | `integerFormat` / `decimalFormat` | `N/A` |
| `boolean` | `booleanFormat` | (empty) |
| `date` / `datetime` | `dateFormat` / `dateTimeFormat` | (empty) |

### Sorting

A missing value sorts as the smallest value by default, ahead of every other value in the field's data type, following the ascending-sort convention used by leading analytics and BI tools.

### Filtering

A missing value is excluded from filter results by default - for example, an `equals` or `between` condition never matches it.

### Aggregation

`sum`, `avg`, `min`, and `max` exclude missing values from the calculation. If every value in a group is missing, the result is `null` rather than `0` - this is standard practice across analytical engines, since a missing result and a true zero mean different things and collapsing them would hide information. `count` also excludes missing values.

`countd` (distinct count) counts a missing value as a distinct value by default, consistent with standard distinct-count semantics in analytical engines. `first` and `last` return the first or last non-missing value in sort order by default. Grouping treats a missing value as its own group rather than dropping those rows.


---
product: "AG Studio"
title: "Data Types"
description: "Studio supports a variety of data types. Instead of being defined directly on fields, data types are defined on . A Format controls formatting along with other behaviour."
framework: angular
version: "3.0.0"
related:
    - title: "Formatting"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/formatting/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/expressions/"
    - title: "Calendars"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/calendars/"
    - title: "Editable Fields"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/creating-editing-fields/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Data Types

Studio supports a variety of data types. Instead of being defined directly on fields, data types are defined on [Formats](https://www.ag-grid.com/studio/archive/3.0.0/angular/formatting/). A Format controls formatting along with other behaviour.

```
const fields = [
    {
        id: 'athlete',
        format: 'textFormat' // textFormat uses the `string` data type
    },
    // ... other fields
];
```

When using [Sync Data](https://www.ag-grid.com/studio/archive/3.0.0/angular/loading-data/#sync-data) and not providing fields, the format is inferred from the data.

#### Data Types

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Data Types](https://www.ag-grid.com/studio/archive/3.0.0/examples/data-types/data-types/angular/)

## Data Types

Each of the data types are described in the table below. The input type is the JavaScript type that is supported in the source data. The default Format is the Format that will be used when inferring fields.

| Data Type | Input Type | Default Format |
| --- | --- | --- |
| `string` | `string` | `textFormat` |
| `number` | `number` | `integerFormat` / `decimalFormat` |
| `boolean` | `boolean` | `booleanFormat` |
| `date` | `Date \| string \| number` | `dateFormat` |
| `datetime` | `Date \| string \| number` | `dateTimeFormat` |

For `date` and `datetime`, the `string` value is expected to be in ISO-8601 format, and the `number` value is Unix epoch.

See [Formatting](https://www.ag-grid.com/studio/archive/3.0.0/angular/formatting/) for how each data type is displayed and how to customise the display format.

## Dictionary Columns

Some data stores a code rather than a label, such as an ISO country code instead of a country name. In Studio, the mapping from code to label is a separate table joined to the table holding the codes, and the user-facing column comes from that dictionary table.

This is not the same as formatting the code for display. Because the label is a real field, you can group, sort, filter and aggregate by it, put it on a chart axis, and use it in an expression. A value formatter only changes what is displayed, so the engine still groups, sorts and filters on the raw code. The mapping is also data, so you can update it without changing any code.

The example below joins a medals table to a countries dictionary. The medals table stores an ISO country code, and the grid shows the country name that the dictionary maps it to.

#### Dictionary Columns

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Dictionary Columns](https://www.ag-grid.com/studio/archive/3.0.0/examples/data-types/dictionary-columns/angular/)

The medals table joins many-to-one to the countries table on the code. The code itself is hidden on both tables, so it does not appear in the field panel. A hidden field can still be used as a join key.

```ts
<ag-studio
    [sources]="sources"
    [relationships]="relationships"
    /* other studio properties ... */ />

this.sources = [{
    id: 'medals',
    data: [
        {
            sport: 'Swimming',
            countryCode: 'USA',
            // ... other fields
        },
        // ... other rows
    ],
    fields: [
        { id: 'countryCode', format: 'textFormat', hide: true },
        // ... other fields
    ],
}, {
    id: 'countries',
    data: [
        { countryCode: 'USA', countryName: 'United States' },
        // ... one row per code
    ],
    fields: [
        { id: 'countryCode', format: 'textFormat', hide: true },
        { id: 'countryName', format: 'textFormat', name: 'Country' },
    ],
}];
this.relationships = [
    {
        id: 'medals-countries',
        source: {
            tableId: 'medals',
            fieldId: 'countryCode',
        },
        target: {
            tableId: 'countries',
            fieldId: 'countryCode',
        },
        type: 'many-to-one',
    },
];
```

Give the dictionary exactly one row per code. A duplicate code turns the join into a one-to-many, which inflates aggregated values. A code with no matching dictionary row leaves the label blank, as described in [Null and Undefined Values](https://www.ag-grid.com/studio/archive/3.0.0/angular/data-types/#null-and-undefined-values).

See [Relationships](https://www.ag-grid.com/studio/archive/3.0.0/angular/data-modelling/#relationships) for how relationships are defined, and [Star Schema](https://www.ag-grid.com/studio/archive/3.0.0/angular/data-modelling/#star-schema) for modelling several dictionary tables around one table of facts.

## Null and Undefined Values

A field value can be missing - either `null` or `undefined`. AG Studio treats both the same way by default, across every data type.

### Display

A missing value is never passed to a Format's value formatter. Instead, the field shows that Format's `blankValue`:

| Data Type | Default Format | Blank display |
| --- | --- | --- |
| `string` | `textFormat` | `(Blanks)` |
| `number` | `integerFormat` / `decimalFormat` | `N/A` |
| `boolean` | `booleanFormat` | (empty) |
| `date` / `datetime` | `dateFormat` / `dateTimeFormat` | (empty) |

### Sorting

A missing value sorts as the smallest value by default, ahead of every other value in the field's data type, following the ascending-sort convention used by leading analytics and BI tools.

### Filtering

A missing value is excluded from filter results by default - for example, an `equals` or `between` condition never matches it.

### Aggregation

`sum`, `avg`, `min`, and `max` exclude missing values from the calculation. If every value in a group is missing, the result is `null` rather than `0` - this is standard practice across analytical engines, since a missing result and a true zero mean different things and collapsing them would hide information. `count` also excludes missing values.

`countd` (distinct count) counts a missing value as a distinct value by default, consistent with standard distinct-count semantics in analytical engines. `first` and `last` return the first or last non-missing value in sort order by default. Grouping treats a missing value as its own group rather than dropping those rows.
